/*
 * ircii.c - Emulation as best as possible of the IRCII client
 * Pinched from the original ctcp.so for eggdrop
 * Questions or comments email jsimm@satexas.com
 */

#define MAKING_WOOBIE
#define MODULE_NAME "ircii"
#include "../../config.h"
#ifdef HAVE_UNAME
# include <sys/utsname.h>
#endif
#include "ircii.h"
#include "../module.h"
#include "../server.mod/server.h"
#include <netinet/in.h>
#include <arpa/inet.h>


static Function * global = NULL, * server_funcs = NULL;

/* The random idle time function */
int i_time = 0;
        void up_i_time () {
        if ((random() & 0xff00) == 0)
        i_time = 0;
        else
        i_time++;
       }

static char ctcp_version[256];
static char ctcp_finger[256];
static char ctcp_userinfo[256];
                        

/* this only handles CHAT requests, otherwise it's handled in 
 * filesys */
static int ctcp_DCC_CHAT(char * nick, char * from, char * handle, 
		 char * object, char * keyword, char * text) {
   char * param, * ip, * prt,buf[512],*msg = buf;
   int i,sock;
   struct userrec * u = get_user_by_handle(userlist,handle);
   struct flag_record fr = {FR_GLOBAL|FR_CHAN|FR_ANYWH,0,0,0,0,0};
   
   context;
   if (strncasecmp(text,"CHAT ",5) || !u)
     return 0;
   strcpy(buf,text+5);
   get_user_flagrec(u,&fr,0);
   param = newsplit(&msg);
   if (dcc_total == max_dcc) {
      if (!quiet_reject) 
	dprintf(DP_HELP, "NOTICE %s :%s\n", nick, DCC_TOOMANYDCCS1);
      putlog(LOG_MISC, "*", DCC_TOOMANYDCCS2, "CHAT", param, nick, from);
   } else if (!(glob_party(fr) || (!require_p && chan_op(fr)))) {
      if (glob_xfer(fr))
	return 0; /* allow filesys to pick up the chat */
      if (!quiet_reject) 
	dprintf(DP_HELP, "NOTICE %s :%s.\n", nick, DCC_REFUSED2);
      putlog(LOG_MISC, "*", "%s: %s!%s", DCC_REFUSED, nick, from);
   } else if (u_pass_match(u,"-")) {
      dprintf(DP_HELP, "NOTICE %s :%s.\n", nick, DCC_REFUSED3);
      putlog(LOG_MISC, "*", "%s: %s!%s", DCC_REFUSED4, nick, from);
   } else {
      ip = newsplit(&msg);
      prt = newsplit(&msg);
      sock = getsock(0);
      if (open_telnet_dcc(sock, ip, prt) < 0) {
	 neterror(buf);
	 dprintf(DP_HELP, "NOTICE %s :%s (%s)\n", nick,
		 DCC_CONNECTFAILED1, buf);
	 putlog(LOG_MISC, "*", "%s: CHAT (%s!%s)", DCC_CONNECTFAILED2,
		nick, from);
	 putlog(LOG_MISC, "*", "    (%s)", buf);
	 killsock(sock);
      } else {
	 i = new_dcc(&DCC_CHAT_PASS,sizeof(struct chat_info));
	 dcc[i].addr = my_atoul(ip);
	 dcc[i].port = atoi(prt);
	 dcc[i].sock = sock;
	 strcpy(dcc[i].nick, u->handle);
	 strcpy(dcc[i].host, from);
	 dcc[i].status = STAT_ECHO;
	 if (glob_party(fr))
	   dcc[i].status |= STAT_PARTY;
	 strcpy(dcc[i].u.chat->con_chan, chanset?chanset->name:"*");
	 dcc[i].timeval = now;
	 dcc[i].user = u;
	 /* ok, we're satisfied with them now: attempt the connect */
	 putlog(LOG_MISC, "*", "DCC connection: CHAT (%s!%s)", nick, from);
	 dprintf(i, "%s\n", DCC_ENTERPASS);
      }
   }
   return 1;
}

static int ctcp_FINGER(char * nick, char * host, char * handle, 
		 char * object, char * keyword, char * text) {
   context;
     simple_sprintf(&ctcp_reply[strlen(ctcp_reply)],
     "\001FINGER (%s) Idle %d seconds\001", botuserhost, i_time);
   return 1;
}

static int ctcp_ECHOPINGERR (char * nick, char * uhost, char * handle,
		       char * object, char * keyword, char * text) {
   context;
   if (strlen(text) <= 80) /* bitch ignores > 80 */
     simple_sprintf(&ctcp_reply[strlen(ctcp_reply)],"\001%s %s\001",
		    keyword,text);
   return 1;
}
static int ctcp_VERSION(char * nick, char * uhost, char * handle)
{
        char * ver_t, * uni_x;
#ifdef HAVE_UNAME
        struct utsname un;
        if (uname(&un) < 0)
         {
                  ver_t = ctcp_version;
                  uni_x = "unknown";
         }
         else
         {
                 ver_t = un.release;
                 uni_x = un.sysname;
         }
#else
        ver_t = ctcp_version;
        uni_x = "unknown";

#endif
      simple_sprintf(&ctcp_reply[strlen(ctcp_reply)],
           "\001VERSION ircII 2.8.2 %s %s :this is a bug free client.  honest\001", uni_x, ver_t); 
       
  return 1;
}

static int ctcp_USERINFO(char * nick, char * uhost, char * handle, 
		 char * object, char * keyword, char * text) {
   context;
   if (ctcp_userinfo[0]) 
     simple_sprintf(&ctcp_reply[strlen(ctcp_reply)],
		    "\001USERINFO %s\001", " ");
   return 1;
}

static int ctcp_CLIENTINFO(char * nick, char * uhost, char * handle,
		     char * object, char * keyword, char * msg) {
   char * p = NULL;
   
   context;
   if (!msg[0])
     p = CLIENTINFO;
  else if (strcasecmp(msg, "sed") == 0)
     p = CLIENTINFO_SED;
  else if (strcasecmp(msg, "utc") == 0)
     p = CLIENTINFO_UTC;
  else if (strcasecmp(msg, "action") == 0)
     p = CLIENTINFO_ACTION;
  else if (strcasecmp(msg, "dcc") == 0)
     p = CLIENTINFO_DCC;
  else if (strcasecmp(msg, "version") == 0)
     p = CLIENTINFO_VERSION;
   else if (strcasecmp(msg, "clientinfo") == 0)
     p = CLIENTINFO_CLIENTINFO;
   else if (strcasecmp(msg, "userinfo") == 0)
     p = CLIENTINFO_USERINFO;
   else if (strcasecmp(msg, "errmsg") == 0)
     p = CLIENTINFO_ERRMSG;
   else if (strcasecmp(msg, "finger") == 0)
     p = CLIENTINFO_FINGER;
   else if (strcasecmp(msg, "time") == 0)
     p = CLIENTINFO_TIME;
   else if (strcasecmp(msg, "ping") == 0)
     p = CLIENTINFO_PING;
   else if (strcasecmp(msg, "echo") == 0)
     p = CLIENTINFO_ECHO;
   if (p == NULL) {
      simple_sprintf(&ctcp_reply[strlen(ctcp_reply)],
		     "\001ERRMSG CLIENTINFO: %s is not a valid function\001",
		     msg);
      } else
	 simple_sprintf(&ctcp_reply[strlen(ctcp_reply)],
			"\001CLIENTINFO %s\001", p);
   return 1;
}

static int ctcp_TIME (char * nick, char * uhost, char * handle, char * object,
		char * keyword, char * text) {
      char tms[81];
   
   context;
   strcpy(tms, ctime(&now));
   tms[strlen(tms) - 1] = 0;
   simple_sprintf(&ctcp_reply[strlen(ctcp_reply)], "\001TIME %s\001", tms);
   return 1;
}

static int ctcp_CHAT (char * nick, char * uhost, char * handle, char * object,
		char * keyword, char * text) {
   struct userrec * u = get_user_by_handle(userlist,handle);
   int atr = u ? u->flags : 0, i, ix = (-1);
   
   context;
   if ((atr & (USER_PARTY | USER_XFER)) ||
       ((atr & USER_OP) && !require_p)) {
      for (i = 0; i < dcc_total; i++) {
	 if ((dcc[i].type->flags & DCT_LISTEN) &&
	     ((strcmp(dcc[i].nick, "(telnet)") == 0) ||
	      (strcmp(dcc[i].nick, "(users)") == 0))) {
	    ix = i;
	    /* do me a favour and don't change this back to a CTCP reply, */
	    /* CTCP replies are NOTICE's this has to be a PRIVMSG */
	    /* -poptix 5/1/97 */
	    dprintf(DP_SERVER, "PRIVMSG %s :\001DCC CHAT chat %lu %u\001\n",
		    nick, 
		    iptolong(natip[0]?(IP) inet_addr(natip):getmyip()),
		    dcc[ix].port);
	 }
      }
      if (ix < 0)
	simple_sprintf(&ctcp_reply[strlen(ctcp_reply)], 
		       "\001ERROR no telnet port\001");
   }
   return 1;
}

static cmd_t myctcp[10] =
{
     { "FINGER", "", ctcp_FINGER, NULL },
     { "ECHO", "", ctcp_ECHOPINGERR, NULL },
     { "PING", "", ctcp_ECHOPINGERR, NULL },
     { "ERRMSG", "", ctcp_ECHOPINGERR, NULL },
     { "VERSION", "", ctcp_VERSION, NULL },
     { "USERINFO", "", ctcp_USERINFO, NULL },
     { "CLIENTINFO", "", ctcp_CLIENTINFO, NULL },
     { "TIME", "", ctcp_TIME, NULL },
     { "CHAT", "", ctcp_CHAT, NULL },
     { "DCC", "", ctcp_DCC_CHAT, "ctcp:DCC" },
};

static tcl_strings mystrings [] =
{
     {"ctcp-version", ctcp_version, 120, 0},
     {"ctcp-finger", ctcp_finger, 120, 0},
     {"ctcp-userinfo", ctcp_userinfo, 120, 0},
     {0, 0, 0, 0}
};

static char *ircii_close()
{
   rem_tcl_strings(mystrings);
   rem_builtins(H_ctcp, myctcp,10);
   del_hook(HOOK_SECONDLY,up_i_time);
   module_undepend(MODULE_NAME);
   return NULL;
}

static void ircii_report (int idx, int details)
{
   context;
   if (details)
      dprintf(idx, "     ircII Client Emulation:\n");
}

char *ircii_start ();


static Function ircii_table[] =
{
   (Function) ircii_start,
   (Function) ircii_close,
   (Function) ircii_report,
   (Function) 0,
};

char *ircii_start (Function * global_funcs)
{
   global = global_funcs;
   context;
   module_register(MODULE_NAME, ircii_table, 2, 0);
   if (!(server_funcs = module_depend(MODULE_NAME, "server", 1, 0)))
      return "You need the server module to use the ircii module.";
   add_tcl_strings(mystrings);
   add_builtins(H_ctcp, myctcp,10);
   add_hook(HOOK_SECONDLY,up_i_time);
   if (!ctcp_version[0]) {
      strncpy(ctcp_version, ver, 160);
      ctcp_version[160] = 0;
   }
   if (!ctcp_finger[0]) {
      strncpy(ctcp_finger, ver, 160);
      ctcp_finger[160] = 0;
   }
   if (!ctcp_userinfo[0]) {
      strncpy(ctcp_userinfo, ver, 160);
      ctcp_userinfo[160] = 0;
   }
   return NULL;
}

